package bmsi.tui;

import java.awt.image.ColorModel;
import java.awt.Color;

public class HiColorModel extends ColorModelPeer {
  public HiColorModel() { super(16); }
  private static short[] mask = new short[] { 0,0xF8,0xFC,0xF8 };
  private static short[] shift = new short[] { 0,8,3,-3 };
  private int extract(int pixel,int i) {
    int m = mask[i];
    int s = shift[i];
    int val;
    if (s < 0)
      val = (pixel << -s) & m;
    else
      val = (pixel >> s) & m;
    if (val > 127)
      val |= ~m & 255;
    return val;
  }
  public int getAlpha(int pixel) { return 255; }
  public int getRed(int pixel) { return extract(pixel,1); }
  public int getGreen(int pixel) { return extract(pixel,2); }
  public int getBlue(int pixel) { return extract(pixel,3); }
  public int getPixel(Color c) {
    int pixel = (c.getRed() & mask[1]) << shift[1];
    pixel |= (c.getGreen() & mask[2]) << shift[2];
    pixel |= (c.getBlue() & mask[3]) >> -shift[3];
    return pixel;
  }
}
