package bmsi.tui;
import java.awt.*;
import java.awt.event.*;
import java.awt.peer.*;

class TUICanvas extends TUIComponent implements CanvasPeer {
  TUICanvas(Canvas c,TUIKit toolkit) { super(c,toolkit); }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWCANVAS,this);
  }
  /** Add rectangle to list of areas to be repainted in ms time.
   * Most TUIComponents are painted entirely by the remote program.
   * A Canvas is painted by the application and we must therefore
   * invoke the application.
   */
  public void repaint(long ms,int x,int y,int w,int h) {
    Graphics g = getGraphics();
    g.clipRect(x,y,w,h);
    target.update(g);
    g.dispose();
  }
}
