package bmsi.tui;
import java.awt.*;
import java.awt.event.*;
import java.awt.peer.*;
import java.io.IOException;

class TUICheckbox extends TUIComponent implements CheckboxPeer {
  TUICheckbox(Checkbox cb,TUIKit toolkit) { super(cb,toolkit); }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWCHECKBOX,this);
  }
  protected void initialize() {
    Checkbox cb = (Checkbox)target;
    String text = cb.getLabel();
    if (text != null)
      setLabel(text);
    setState(cb.getState());
    super.initialize();
  }
  public void setLabel(String s) { toolkit.writeCmd(this,SETTEXT,s); }
  public void setState(boolean state) {
    toolkit.writeCmd(this,SETSTATE,state ? 1 : 0);
  }
  public void setCheckboxGroup(CheckboxGroup g) { }
  /** Handle checkbox state locally. */
  public void remoteMethod(int cmd) throws IOException {
    if (cmd == MENUPICK) {
      Checkbox cb = (Checkbox)target;
      boolean flag = !cb.getState();
      cb.setState(flag);
      toolkit.theQueue.postEvent(
	new ItemEvent(cb,ItemEvent.ITEM_STATE_CHANGED,cb.getLabel(),
	flag ? ItemEvent.SELECTED : ItemEvent.DESELECTED)
      );
      return;
    }
    super.remoteMethod(cmd);
  }
  public Dimension getMinimumSize() {
    Checkbox cb = (Checkbox)target;
    return toolkit.scale(new Dimension(cb.getLabel().length() + 4,1));
  }
}
