package bmsi.tui;
import java.awt.*;
import java.awt.event.*;
import java.awt.peer.*;
import java.io.IOException;

/** TUIChoice is straightforward.  We handle selection changes locally
  so that we can post the corresponding ItemEvent. */

class TUIChoice extends TUIComponent implements ChoicePeer {
  TUIChoice(Choice choice,TUIKit toolkit) { super(choice,toolkit); }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWCHOICE,this);
  }
  public Dimension getMinimumSize() {
    int width = target.getSize().width;
    return toolkit.scale(new Dimension((width > 0) ? width : 4,1));
  }
  protected void initialize() {
    Choice choice = (Choice)target;
    int n = choice.getItemCount();
    for (int i = 0; i < n; ++i)
      add(choice.getItem(i),i);
    select(choice.getSelectedIndex());
    super.initialize();
  }
  public void add(String s,int i) { toolkit.writeCmd(this,ADDCHOICEITEM,s,i); }
  public void select(int idx) { toolkit.writeCmd(this,SELECTCHOICE,idx); }
  public void remove(int idx) { toolkit.writeCmd(this,REMOVECHOICE,idx); }
  public void remoteMethod(int cmd) throws IOException {
    if (cmd == SELECTCHOICE) {
      Choice choice = (Choice)target;
      int i = toolkit.readShort();
      choice.select(i);
      toolkit.theQueue.postEvent(
	new ItemEvent(choice,ItemEvent.ITEM_STATE_CHANGED,
	choice.getSelectedItem(),ItemEvent.SELECTED)
      );
      return;
    }
    super.remoteMethod(cmd);
  }
  /* jdk 1.0 compatibility */
  public final void addItem(String s,int i) { add(s,i); }
}
