package bmsi.tui;

import java.awt.*;
import java.awt.peer.*;

class TUIFrame extends TUIFramedWindow implements FramePeer {
  TUIFrame(Frame f,TUIKit toolkit) { super(f,toolkit); }
  protected void initialize() {
    Frame frame = (Frame)target;
    String title = frame.getTitle();
    if (title != null)
      setTitle(title);
    if (!frame.isResizable())
      setResizable(false);
    MenuBar menu = frame.getMenuBar();
    if (menu != null) {
      if (menu.getPeer() == null)
	menu.addNotify();
      setMenuBar(menu);
    }
    super.initialize();
  }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWFRAME,this);
  }
  /** While most text terminals support icons via font download, we
   have no time for such foolishness :-) */
  public void setIconImage(Image img) { }
  public void setMenuBar(MenuBar mnu) {
    int id = -1;
    if (mnu != null) {
      TUIMenuBar peer = (TUIMenuBar)mnu.getPeer();
      id = peer.getID();
    }
    toolkit.writeCmd(this,SETMENU,id);
  }
}
