package bmsi.tui;

import java.awt.*;
import java.awt.peer.MenuBarPeer;

class TUIMenuBar extends TUIMenuComponent implements MenuBarPeer {
  /** Although JDK 1.1 will add the MenuItems to a MenuPeer, it will
    not add Menus to a MenuBarPeer, so we have to do it ourselves.   Wierd. */
  protected void initialize() {
    MenuBar m = (MenuBar)target;
    // java.awt in JDK 1.0 will addNotify a parent menu before it's submenus!
    // We have to addNotify() ourselves for the child Menus in this case.
    Menu menu = m.getHelpMenu();
    if (menu != null) {
      //if (menu.getPeer() == null)
      //  menu.addNotify();
      if (menu.getPeer() != null)
	addHelpMenu(menu);
    }
    int n = m.countMenus();
    for (int i = 0; i < n; ++i) {
      menu = m.getMenu(i);
      //if (menu.getPeer() == null)
      //  menu.addNotify();
      if (menu.getPeer() != null)
	addMenu(menu);
    }
  }

  protected void create(TUIMenuComponent parent) {
    winID = toolkit.createRemotePeer(parent,NEWMENUBAR,this);
  }

  TUIMenuBar(MenuBar m,TUIKit toolkit) { super(m,toolkit); }

  public void addHelpMenu(Menu m) {
    TUIMenu menu = (TUIMenu)m.getPeer();
    toolkit.writeCmd(this,ADDHELPMENU,menu.winID);
  }

  public void addMenu(Menu m) {
    TUIMenu menu = (TUIMenu)m.getPeer();
    toolkit.writeCmd(this,ADDMENU,menu.winID);
  }

  public void delMenu(int pos) {
    toolkit.writeCmd(this,DELMENU,pos);
  }
}
