package bmsi.tui;

import java.awt.*;
import java.awt.peer.MenuComponentPeer;
import java.io.IOException;

/** MenuComponents are fairly mindless implementations of RemotePeer */

abstract class TUIMenuComponent implements MenuComponentPeer, RemotePeer {
  protected int winID;
  protected MenuComponent target;
  protected TUIKit toolkit;
  protected abstract void initialize();
  protected abstract void create(TUIMenuComponent parent);
  TUIMenuComponent(MenuComponent m,TUIKit toolkit) {
    target = m;
    this.toolkit = toolkit;
    MenuContainer parent = m.getParent();
    TUIMenuComponent parentpeer = null;
    if (parent != null)
      if (parent instanceof MenuBar)
	parentpeer = (TUIMenuComponent)((MenuBar)parent).getPeer();
      else if (parent instanceof Menu)
	parentpeer = (TUIMenuComponent)((Menu)parent).getPeer();
    create(parentpeer);
    initialize();
  }
  public void handleEvent(AWTEvent e) { }

  public int getID() { return winID; }
  public Object getTarget() { return target; }

  protected void finalize() { dispose(); }
  public void dispose() {
    toolkit.removePeer(winID);
    winID = -1;
    target = null;
  }
  public void remoteMethod(int cmd) throws IOException { }
}
