package bmsi.tui;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.peer.*;
import java.io.IOException;

class TUIMenuItem extends TUIMenuComponent implements MenuItemPeer {
  private boolean enabled = true;	// track state locally
  TUIMenuItem(MenuItem m,TUIKit toolkit) { super(m,toolkit); }
  protected void initialize() {
    MenuItem m = (MenuItem)target;
    setLabel(m.getLabel());
    if (!m.isEnabled())
      setEnabled(false);
  }
  protected void create(TUIMenuComponent parent) {
    winID = toolkit.createRemotePeer(parent,NEWMENUITEM,this);
  }
  public void setEnabled(boolean a) {
    if (a == enabled) return;
    enabled = a;
    if (a)
      toolkit.writeCmd(this,ENABLE);
    else
      toolkit.writeCmd(this,DISABLE);
  }
  public void setLabel(String lab) { toolkit.writeCmd(this,SETLABEL,lab); }
  public void remoteMethod(int cmd) throws IOException {
    MenuItem item = (MenuItem)target;
    /*JDK1.0: item.postEvent(new Event(target,Event.ACTION_EVENT,
	item.getLabel())); */
    toolkit.theQueue.postEvent(
      new ActionEvent(item,ActionEvent.ACTION_PERFORMED,
      item.getActionCommand())
    );
  }
  /* jdk 1.0 compatibility */
  public final void disable() { setEnabled(false); }
  public final void enable() { setEnabled(true); }
}
