/* $Log
 */
package bmsi.tui;

import java.awt.AWTEvent;
import java.awt.peer.ActiveEvent;

/** TUISync is responsible for ensuring that a toolkit.flush() is
    eventually called.  We currently do this by queueing a new event
    to a dummy component. */
class TUISync extends AWTEvent implements ActiveEvent {
  private RemoteToolkit toolkit;
  TUISync(RemoteToolkit toolkit) {
    super(toolkit,0);
    this.toolkit = toolkit;
  }
  public void dispatch() { toolkit.flush(); }
  //  arrange for flush at a later time
  final void queue() { toolkit.theQueue.postEvent(this); }
}
