package bmsi.tui;
import java.awt.*;
import java.awt.peer.TextFieldPeer;

class TUITextField extends TUITextComponent implements TextFieldPeer {
  TUITextField(TextField t,TUIKit toolkit) { super(t,toolkit); }
  protected void create(TUIContainer parent) {
    winID = toolkit.createRemotePeer(parent,NEWTEXTFIELD,this);
  }
  protected void initialize() {
    TextField tf = (TextField)target;
    if (tf.echoCharIsSet())
      setEchoChar(tf.getEchoChar());
    setColumns(tf.getColumns());
    super.initialize();
  }
  public void setEchoChar(char c) {
    toolkit.writeCmd(this,SETECHOCHAR,c);
  }
  public Dimension getPreferredSize(int cols) {
    return toolkit.scale(new Dimension(cols,1));
  }
  public Dimension getMinimumSize(int cols) {
    if (cols > 20)
      return toolkit.scale(new Dimension(20,1));
    return getPreferredSize(cols);
  }

  /* jdk 1.0 compatibility */
  public final void setEchoCharacter(char c) { setEchoChar(c); }
  public final Dimension preferredSize(int cols) {
    return getPreferredSize(cols);
  }
  public final Dimension minimumSize(int cols) {
    return getMinimumSize(cols);
  }
}
