package bmsi.tui;
import java.awt.*;
import java.awt.event.*;
import java.io.IOException;
import java.net.URL;

public class TestFrame extends Frame
  implements AdjustmentListener, ActionListener {
  String txt = "Hello world!";
  TextArea ta = new TextArea("",10,40,TextArea.SCROLLBARS_VERTICAL_ONLY);
  PopupMenu taPopup = new PopupMenu();
  Label sbval = new Label("000");

  void listenAll(Menu m) {
    int n = m.getItemCount();
    for (int i = 0; i < n; ++i)
      m.getItem(i).addActionListener(this);
  }

  public TestFrame() {
    super("TUI Test!");
    //reshape(10,2,40,20);
    MenuBar menu = new MenuBar();
    setMenuBar(menu);
    Menu m = new Menu("Test");
    m.add("Help");
    m.add("\u03C0");
    m.add("Exit");
    menu.add(m);
    listenAll(m);
    setLayout(new BorderLayout());
    Panel toppan = new Panel();
    //toppan.setLayout(new FlowLayout(FlowLayout.CENTER,1,0));
    toppan.setLayout(new BorderLayout());
    List list = new List();
    list.add("This way");
    list.add("That way");
    list.add("The other way");
    toppan.add(list,"West");
    Scrollbar sb = new Scrollbar(Scrollbar.HORIZONTAL);
    sb.addAdjustmentListener(this);
    toppan.add(sb,"South");
    toppan.add(sbval,"East");
    add("North",toppan);
    add("Center",ta);
    ta.add(taPopup);
    taPopup.add(new MenuItem("Clear"));
    taPopup.add(new MenuItem("Init"));
    taPopup.add(new MenuItem("Exit"));
    listenAll(taPopup);
    //CheckboxGroup grp = new CheckboxGroup();
    Panel botpan = new Panel();
    Choice choice = new Choice();
    choice.addItem("Red");
    choice.addItem("Green");
    choice.addItem("Blue");
    botpan.setLayout(new GridLayout(1,2));
    botpan.add(new Checkbox("Word Wrap"));
    botpan.add(choice);
    add("South",botpan);
    pack();
    addKeyListener(
      new KeyAdapter() {
	public void keyPressed(KeyEvent k) {
	  if (k.getKeyCode() == k.VK_F10)
	    taPopup.show(ta,10,10);
	}
      }
    );
    show();
    ta.requestFocus();
  }

  public void adjustmentValueChanged(AdjustmentEvent e) {
    int val = e.getValue();
    sbval.setText("" + val);
  }

  public void actionPerformed(ActionEvent e) {
    txt = e.getActionCommand();
    if (txt.equals("Help"))
      try {
	((RemoteToolkit)getToolkit()).showDocument(
	  new URL("http://bmsaix.bmsi.com/java.html")
	);
      }
      catch (Exception x) { }
    if (txt.equals("Exit"))
      System.exit(0);
    if (txt.equals("Clear"))
      ta.setText("");
    if (txt.equals("Init"))
      ta.setText("Jesus loves me this I know\nFor the Bible tells me so.\n" +
	       "Little ones to him belong\nThey are weak but he is strong.\n");
  }

  public static void main(String[] args) throws Exception {
    TestFrame test = new TestFrame();
  }
}
